package com.stronglink.exampleu1;

import com.xminnov.IvrJackAdapter;
import com.xminnov.IvrJackService;
import com.xminnov.IvrJackStatus;

import android.app.Activity;
import java.lang.ref.WeakReference;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class Demo extends Activity implements IvrJackAdapter {
	
	private TextView txtSN = null;
	private TextView lblUID = null;
	private TextView lblBlock1 = null;
	private TextView lblBlock2 = null;
	private TextView txtUID = null;
	private TextView txtBlock1 = null;
	private TextView txtBlock2 = null;
	private CheckBox chkReadBlock = null;
	private Button btnQuery = null;
	private ImageView imgPlugout = null;
	private TextView txtStatus = null;
	private TextView txtDate = null;
    private ProgressDialog pd; 
    private boolean bSuccess;
    private String cMsg;
    private MyHandler handler = null;
    private byte[] data = new byte[32];
    private boolean bReadBlock = false; 
    private boolean bCancel = false;
    
    IvrJackService reader = null;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		btnQuery = (Button)findViewById(R.id.btnQuery);
		btnQuery.setEnabled(false);
		txtStatus = (TextView)findViewById(R.id.txtStatus);
		txtDate = (TextView)findViewById(R.id.txtDate);
		lblUID = (TextView)findViewById(R.id.textView1);
		lblBlock1 = (TextView)findViewById(R.id.TextView03);
		lblBlock2 = (TextView)findViewById(R.id.TextView02);
		txtUID = (TextView)findViewById(R.id.txtUID);
		txtBlock1 = (TextView)findViewById(R.id.txtBlock1);
		txtBlock2 = (TextView)findViewById(R.id.txtBlock2);
		chkReadBlock = (CheckBox)findViewById(R.id.chkReadBlock);
		imgPlugout = (ImageView)findViewById(R.id.imgPlugout);
		txtSN = (TextView) findViewById(R.id.txtSN);
		//
		handler = new MyHandler(this);
		btnQuery.setOnClickListener(new btnQuery_Click());
		reader = new IvrJackService();
		reader.open(this, this);
	}
	
	@Override 
	public void onStart() {
		super.onStart();  
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd  EEEE", Locale.ENGLISH);     
    	Date curDate = new Date(System.currentTimeMillis());//ȡǰʱ   
		txtDate.setText(formatter.format(curDate));
	}
	
	@Override
	public void onStop() {
		super.onStop();
	}
	
	@Override  
    public void onDestroy() { 
        super.onDestroy();  
    }
	
	static class MyHandler extends Handler {  
        WeakReference<Demo> outerClass;  
      
        MyHandler(Demo activity) {  
            outerClass = new WeakReference<Demo>(activity);  
        }  
      
		@Override
		public void handleMessage(Message msg) {
			Demo theClass = outerClass.get();  
			switch (msg.what) {
				case 1:
					theClass.pd.dismiss(); // رProgressDialog
					theClass.btnQuery.setEnabled(true);
					if (theClass.bSuccess) {
						String uid = String.format("%08X", theClass.reader.uid);
	    				theClass.txtUID.setText(uid);
	    				if (theClass.chkReadBlock.isChecked()) {
	    					String sData = "";
	    					for(int i = 0; i < 16; i++)
	    					{
	    						sData += String.format("%02X ", (byte)theClass.data[i]);
	    					}
	    					theClass.txtBlock1.setText(sData);
	    					sData = "";
	    					for(int i = 16; i < 32; i++)
	    					{
	    						sData += String.format("%02X ", (byte)theClass.data[i]);
	    					}
	    					theClass.txtBlock2.setText(sData);
	    				}
					} else {
						Toast.makeText(theClass, theClass.cMsg, Toast.LENGTH_SHORT).show();
					}
					break;
	
				case 11:
					//theClass.pd.setMessage("ʶǩ...");
					theClass.pd.setMessage("distinguishing tags ...");
					break;
			}
		}
	};
	
	//ѯť¼
    private class btnQuery_Click implements android.view.View.OnClickListener
    {
		public void onClick(View v) 
		{
			btnQuery.setEnabled(false);
			txtUID.setText("");
			txtBlock1.setText("");
			txtBlock2.setText("");
			bReadBlock = chkReadBlock.isChecked();
			//
			//pd = ProgressDialog.show(Demo.this, "", "ǩʶ...");
			pd = ProgressDialog.show(Demo.this, "", "Start distinguish tags ...");
            new Thread(){  
                @Override  
                public void run() {  
                    try {
                    	//cMsg = "豸ͨѶʧܣȷǷã"; 
                    	cMsg = "Communication is fail,please check whether  connect is ok!"; 
                    	bSuccess = false;
						int ret = reader.readTag();
						if (ret == 0 && !bCancel) {
							handler.sendEmptyMessage(11);  
							ret = reader.getTagUID();
							if (ret == 0 && reader.uid == 0)
								ret = 9;
							if (ret == 0 && !bCancel) {
								if (bReadBlock) {
									byte pwds[] = new byte[6];
									for (int i = 0; i < 6; i++) {
										pwds[i] = (byte) 0xFF;
									}
									ret = reader.tagReadBlockData((byte)2, (byte)0, (byte)3, (byte)0, pwds, data);
//									ret = reader.tagAuthenticate((byte) 2, data);
//									if (ret == 0) {
//										for (int i = 0; i < 16; i++) {
//											data[i] = (byte) i;
//										}
//										ret = reader.tagWriteData((byte) 0, data);
//										if (ret == 0)
//											ret = reader.tagReadData((byte) 0, data);
//									}
								}
								if (ret == 0) {
									bSuccess = true;
								}
								else if (ret > 9)
									//cMsg = "ȡǩʧܡ";
									cMsg = "Read tag data fail!";
							}
							else if (ret == 9) {
								//cMsg = "δʶǩ뽫豸ǰ˿ǩ";
								cMsg = "can't find tag,please put tag near device";
							}
						}
						else if (ret == -1) {
							//cMsg = "豸㣬磡";
							cMsg = "Devive need more battery,please charge it! ";
						}
					} catch (Exception e) {
						//cMsg = "δ֪ϵӦ̡";
						cMsg = "unknown err,please communicate with provider."; 
                    	bSuccess = false;
					}
                    finally {
                    }
                    handler.sendEmptyMessage(1);  
                }}.start();

		}	  
    }
    

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
    	if (keyCode == KeyEvent.KEYCODE_BACK) { 
 			reader.close();
	   		finish();
	   		System.runFinalizersOnExit(true);
	   		System.exit(0);
 		   	return true;
 	   	}else{       
 	   		return super.onKeyDown(keyCode, event);
 	   	} 
    }

	@Override
	public void onConnect(String arg0) {
		txtSN.setText("SN:" + arg0);
	}

	@Override
	public void onDisconnect() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onStatusChange(IvrJackStatus arg0) {
		switch (arg0) {
			case ijsDetecting: 
				//pd = ProgressDialog.show(Demo.this, "", "ʶ豸...");
				pd = ProgressDialog.show(Demo.this, "", "distinguishing device...");
				break;
				
			case ijsRecognized:
				pd.dismiss();
				txtUID.setText("");
				txtBlock1.setText("");
				txtBlock2.setText("");
				imgPlugout.setVisibility(View.GONE);
				btnQuery.setVisibility(View.VISIBLE);					
				txtSN.setVisibility(View.VISIBLE);
				lblUID.setVisibility(View.VISIBLE);
				lblBlock1.setVisibility(View.VISIBLE);
				lblBlock2.setVisibility(View.VISIBLE);
				txtUID.setVisibility(View.VISIBLE);
				txtBlock1.setVisibility(View.VISIBLE);
				txtBlock2.setVisibility(View.VISIBLE);
				chkReadBlock.setVisibility(View.VISIBLE);
				//txtStatus.setText("ӭʹ");
				txtStatus.setText("Welcome to use!");
				btnQuery.setEnabled(true);
				//Toast.makeText(this, "豸ʶ", Toast.LENGTH_SHORT).show();
				Toast.makeText(this, "Device is connected", Toast.LENGTH_SHORT).show();
				break;
				
			case ijsUnRecognized:
				pd.dismiss();
				
				//Toast.makeText(this, "豸δʶ", Toast.LENGTH_SHORT).show();
				Toast.makeText(this, "Device is not connected", Toast.LENGTH_SHORT).show();
				break;
				
			case ijsPlugout:
				//txtStatus.setText("û豸");
				txtStatus.setText("No device!");
				btnQuery.setEnabled(false);
				imgPlugout.setVisibility(View.VISIBLE);
    			btnQuery.setVisibility(View.INVISIBLE);
    			txtSN.setVisibility(View.INVISIBLE);
    			lblUID.setVisibility(View.INVISIBLE);
    			lblBlock1.setVisibility(View.INVISIBLE);
    			lblBlock2.setVisibility(View.INVISIBLE);
    			txtUID.setVisibility(View.INVISIBLE);
    			txtBlock1.setVisibility(View.INVISIBLE);
    			txtBlock2.setVisibility(View.INVISIBLE);
    			chkReadBlock.setVisibility(View.INVISIBLE);
				//Toast.makeText(this, "豸Ѳ", Toast.LENGTH_SHORT).show();
    			Toast.makeText(this, "Device is plug out", Toast.LENGTH_SHORT).show();
				break;
		}
	}
    
}

